<app-loading *ngIf='isLoading'></app-loading>
<div id='request-form'>
  <form nz-form [formGroup]="form" class="content__item content__item--border bg__content--default" scroll-spy>
    <div nz-row [nzGutter]="[30,30]">
      <!-- Người làm đơn -->
      <div nz-col nzXs="24" nzLg="6">
        <employee-data-picker [mbCanText]="true" [mbType]="isSubmitted && f['employeeId'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && f['employeeId'].errors != null" [mbErrors]="f['employeeId'].errors"
          [mbErrorDefs]="[
              { errorName: 'required', errorDescription: 'staffAbs.timekeepingManagement.requestsLeave.validate.required' | translate: {'param': 'staffAbs.timekeepingManagement.requestsLeave.requestsPerson' | translate}},
              { errorName: 'personalTypeOther', errorDescription: 'staffAbs.timekeepingManagement.requestsLeave.validate.personalTypeOther' | translate}
          ]" [formControlName]="'employeeId'"
          (selectedChange)="changeEmployee($event)"
          mbLabelText="{{'staffAbs.timekeepingManagement.requestsLeave.requestsPerson' | translate}} <span class='label__required'>*</span>">
        </employee-data-picker>
      </div>
      <!-- Danh sách loại đơn -->
      <div nz-col nzXs="24" nzLg="24">
        <ng-container formArrayName="listAbsRequestLeaves">
          <ng-container *ngFor="let reason of reasons.controls; let i = index; let first = first">
            <div nz-row [nzGutter]="[30, 10]" class="direct__managers" [formGroupName]="i">
              <div nz-col nzXs="24" nzLg="6">
                <mb-select [mbDataSelects]="listReasonLeave" mbKeyLabel="name" mbKeyValue="reasonLeaveId"
                  [mbType]="isSubmitted && reason.get('reasonLeaveId').errors ? 'error' : 'default'"
                  [mbShowError]="isSubmitted && reason.get('reasonLeaveId').errors != null"
                  [mbErrors]="reason.get('reasonLeaveId').errors" [mbDisable]="screenMode == SCREEN_MODE.VIEW"
                  [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffAbs.timekeepingManagement.requestsLeave.validate.required' | translate: {'param': 'staffAbs.timekeepingManagement.requestsLeave.reasonLeave' | translate}}]"
                  mbLabelText="{{'staffAbs.timekeepingManagement.requestsLeave.reasonLeave' | translate}} <span class='label__required'>*</span>"
                  [mbOptionHeightPx]="56" [mbOptionOverflowSize]="5"
                  mbPlaceholder="--{{'staffAbs.timekeepingManagement.requestsLeave.reasonLeave' | translate}}--"
                  [formControlName]="'reasonLeaveId'" (ngModelChange)="onChangeReason(i)"></mb-select>
              </div>
              <div nz-col nzXs="24" nzLg="6">
                <mb-date-time-work [mbDisabled]="screenMode == SCREEN_MODE.VIEW"
                  [mbType]="isSubmitted && reason.get('fromTime').errors  ? 'error' : 'default'"
                  [mbShowError]="isSubmitted && reason.get('fromTime').errors != null"
                  [mbErrors]="isSubmitted && reason.get('fromTime').errors" [mbErrorDefs]="[
                      { errorName: 'required', errorDescription: 'staffAbs.timekeepingManagement.requestsLeave.validate.required' | translate: {'param': 'staffAbs.timekeepingManagement.requestsLeave.fromTime' | translate}},
                      { errorName: 'dublicateTime', errorDescription: 'staffAbs.timekeepingManagement.requestsLeave.validate.dublicateTime' | translate}
                    ]" mbPlaceholderText="--{{'staffAbs.timekeepingManagement.requestsLeave.fromTime' | translate}}--"
                  mbLabelText="{{'staffAbs.timekeepingManagement.requestsLeave.fromTime' | translate}} <span class='label__required'>*</span>"
                  [formControlName]="'fromTime'" (ngModelChange)="onChangeReason(i)">
                </mb-date-time-work>
              </div>
              <div nz-col nzXs="24" nzLg="6">
                <mb-date-time-work [mbIsStartTime]="false" [mbDisabled]="screenMode == SCREEN_MODE.VIEW"
                  [mbType]="isSubmitted && (reason.get('toTime').errors || reason.errors) ? 'error' : 'default'"
                  [mbShowError]="isSubmitted && (reason.get('toTime').errors || reason.errors) != null"
                  [mbErrors]="reason.get('toTime').errors ? reason.get('toTime').errors : ( reason.errors ? reason.errors : null)"
                  [mbErrorDefs]="[
                      { errorName: 'required', errorDescription: 'staffAbs.timekeepingManagement.requestsLeave.validate.required' | translate: {'param': 'staffAbs.timekeepingManagement.requestsLeave.toTime' | translate}},
                      { errorName: 'rangeDateError', errorDescription: 'staffAbs.validate.rangeDate.pareDateMore' | translate: {toDate: 'staffAbs.timekeepingManagement.requestsLeave.toTime' | translate, fromDate: 'staffAbs.timekeepingManagement.requestsLeave.fromTime' | translate}},
                      { errorName: 'dublicateTime', errorDescription: 'staffAbs.timekeepingManagement.requestsLeave.validate.dublicateTime' | translate}
                    ]" mbPlaceholderText="--{{'staffAbs.timekeepingManagement.requestsLeave.toTime' | translate}}--"
                  mbLabelText="{{'staffAbs.timekeepingManagement.requestsLeave.toTime' | translate}} <span class='label__required'>*</span>"
                  [formControlName]="'toTime'" (ngModelChange)="onChangeReason(i)">
                </mb-date-time-work>
              </div>
              <div *ngIf="screenMode != SCREEN_MODE.VIEW" nz-col nzXs="24" nzLg="6" class="area-action">
                <mb-button mbButtonIconType="AWESOME" mbPrefixIcon="far fa-plus-circle" mbButtonSize="VERY_LARGE"
                  mbButtonTextColor="#fff" mbButtonType="NO_BORDER" (click)="addReason()" mbButtonBgColor="#141ED2">
                </mb-button>
                <mb-button mbButtonIconType="AWESOME" mbPrefixIcon="far fa-trash-alt" mbButtonSize="VERY_LARGE"
                  mbButtonTextColor="#fff" mbButtonType="NO_BORDER" (click)="removeReason(i)" mbButtonBgColor="#FA0B0B">
                </mb-button>
              </div>
            </div>
          </ng-container>
        </ng-container>
      </div>
      <div nz-col nzXs="24" nzLg="6">
        <mb-text-label mbLabelText="{{'staffAbs.timekeepingManagement.requestsLeave.numberDayLeave' | translate}}"
          [mbLabelValue]="f['allDays'].value">
        </mb-text-label>
      </div>
      <div nz-col nzXs="24" nzLg="6">
        <mb-text-label mbLabelText="{{'staffAbs.timekeepingManagement.requestsLeave.numberDayWorkLeave' | translate}}"
          [mbLabelValue]="f['totalDays'].value">
        </mb-text-label>
      </div>
      <div nz-col nzXs="24" nzLg="24">
        <mb-input-text formControlName="reasonDetail" [mbIsTextAre]="true" [mbMaxLength]="2000"
          [mbConfig]="{ rows: 3, autoSize: true }"
          [mbType]="isSubmitted && f['reasonDetail'].errors ? 'error' : 'default'"
          [mbDisable]="screenMode == SCREEN_MODE.VIEW" [mbShowError]="isSubmitted && f['reasonDetail'].errors != null"
          [mbErrors]="f['reasonDetail'].errors"
          [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'staffAbs.timekeepingManagement.requestsLeave.validate.maxLength' | translate: {'numberLength': '2000' }}]"
          mbPlaceholderText="--{{'staffAbs.timekeepingManagement.requestsLeave.reasonDetail' | translate}}--"
          mbLabelText="{{'staffAbs.timekeepingManagement.requestsLeave.reasonDetail' | translate}}">
        </mb-input-text>
      </div>
      <!-- Danh sách người tiếp nhận -->
      <div nz-col nzXs="24" nzLg="24">
        <ng-container formArrayName="listAbsRequestSupporters">
          <ng-container *ngFor="let supporter of supporters.controls; let i = index; let first = first">
            <div nz-row [nzGutter]="[30, 10]" class="direct__managers" [formGroupName]="i">
              <div nz-col nzXs="24" nzLg="6">
                <employee-data-picker [mbCanText]="true" [mbDisable]="screenMode == SCREEN_MODE.VIEW"
                  [mbType]="isSubmitted && supporter.get('employeeId').errors ? 'error' : 'default'"
                  [mbShowError]="isSubmitted && supporter.get('employeeId').errors != null"
                  [mbErrors]="supporter.get('employeeId').errors"
                  [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffAbs.timekeepingManagement.requestsLeave.validate.required' | translate: {'param': 'staffAbs.timekeepingManagement.requestsLeave.supporter' | translate}}
                                  ,{ errorName: 'duplicate', errorDescription: 'staffAbs.timekeepingManagement.requestsLeave.validate.duplicate' | translate }
                                  ,{ errorName: 'duplicateEmployee', errorDescription: 'staffAbs.timekeepingManagement.requestsLeave.validate.duplicateEmployee' | translate }]"
                  [formControlName]="'employeeId'"
                  mbLabelText="{{'staffAbs.timekeepingManagement.requestsLeave.supporter' | translate}} <span class='label__required'>*</span>">
                </employee-data-picker>
              </div>
              <div nz-col nzXs="24" nzLg="12">
                <mb-input-text formControlName="taskContent" [mbMaxLength]="2000" [mbIsTextAre]="true"
                  [mbConfig]="{ rows: 3, autoSize: true }"
                  [mbType]="isSubmitted && supporter.get('taskContent').errors ? 'error' : 'default'"
                  [mbShowError]="isSubmitted && supporter.get('taskContent').errors != null"
                  [mbErrors]="supporter.get('taskContent').errors" [mbDisable]="screenMode == SCREEN_MODE.VIEW"
                  [mbErrorDefs]="[
                      { errorName: 'required', errorDescription: 'staffAbs.timekeepingManagement.requestsLeave.validate.required' | translate: {'param': 'staffAbs.timekeepingManagement.requestsLeave.taskContent' | translate}}
                      , { errorName: 'maxlength', errorDescription: 'staffAbs.timekeepingManagement.requestsLeave.validate.maxLength' | translate: {'numberLength': '2000' }}
                    ]"
                  mbPlaceholderText="--{{'staffAbs.timekeepingManagement.requestsLeave.taskContent' | translate}}--"
                  mbLabelText="{{'staffAbs.timekeepingManagement.requestsLeave.taskContent' | translate}} <span class='label__required'>*</span>">
                </mb-input-text>
              </div>
              <div *ngIf="screenMode != SCREEN_MODE.VIEW" nz-col nzXs="24" nzLg="6" class="area-action">
                <mb-button mbButtonIconType="AWESOME" mbPrefixIcon="far fa-plus-circle" mbButtonSize="VERY_LARGE"
                  mbButtonTextColor="#fff" mbButtonType="NO_BORDER" (click)="addSupporter()" mbButtonBgColor="#141ED2">
                </mb-button>
                <mb-button mbButtonIconType="AWESOME" mbPrefixIcon="far fa-trash-alt" mbButtonSize="VERY_LARGE"
                  mbButtonTextColor="#fff" mbButtonType="NO_BORDER" (click)="removeSupporter(i)"
                  mbButtonBgColor="#FA0B0B">
                </mb-button>
              </div>
            </div>
          </ng-container>
        </ng-container>
      </div>
      <!-- File đính kèm -->
      <div nz-col nzXs="24" nzLg="24">
        <label class="input__label">{{'staffAbs.label.file' | translate}}<span class='label__required'>*</span></label>
        <nz-upload
        [nzAccept]="fileType" nzType="drag" [nzMultiple]=" true" [(nzFileList)]="fileList" [nzBeforeUpload]="beforeUpload"
        [nzRemove]="removeFile" [nzDownload]="downloadFile">
          <p class="ant-upload-drag-icon">
            <em nz-icon nzType="inbox"></em>
          </p>
          <p class="ant-upload-text">{{'common.upload.description'|translate}}</p>
          <p class="ant-upload-hint">
            {{'common.upload.supportType'|translate}}
          </p>
        </nz-upload>
      </div>
      <!-- !!!Error: File đính kèm bắt buộc nhập -->
      <div nz-col nzXs="24" nzLg="12" class="input__group fileEmptyMessage" *ngIf="isSubmitted && isFileEmpty">
        <div class="show-error">
          <em nz-icon nzType="close-circle" nzTheme="outline"></em>
          <span class="text__message">{{'staffAbs.validate.fileRequired' | translate}}</span>
        </div>
      </div>
      <!--End: Error: File đính kèm bắt buộc nhập-->
      <!-- Người xét duyệt - Người phê duyệt end -->
      <!-- <div nz-col nzXs="24" nzLg="24" class="text-right">
        <mb-button mbButtonSize='SMALL' mbButtonAvailableStyle='DEFAULT' (click)="onCancel()"
          mbButtonText="{{'staffAbs.timekeepingManagement.requestsLeave.cancel' | translate}}"></mb-button>
        <mb-button *ngIf="screenMode == SCREEN_MODE.CREATE || screenMode == SCREEN_MODE.UPDATE" mbButtonSize='SMALL'
          mbButtonAvailableStyle='DANGER' mbButtonText="{{'staffAbs.timekeepingManagement.requestsLeave.save' | translate}}"
          (click)="onSave()"></mb-button>
        <mb-button *ngIf="screenMode == SCREEN_MODE.CREATE || screenMode == SCREEN_MODE.UPDATE" mbButtonSize='SMALL'
          mbButtonAvailableStyle='PRIMARY' [mbIsDisable]="!f['isCommitted'].value"
          mbButtonText="{{'staffAbs.timekeepingManagement.requestsLeave.send' | translate}}" (click)="onSave(REQUEST_STATUS.WAIT_APPROVE)">
        </mb-button>
      </div> -->
    </div>
    <div *nzModalFooter>
      <button nz-button nzType="default" (click)="close()">{{'staffAbs.approvalFlow.cancel' | translate}}</button>
      <button nz-button nzType="primary" (click)="onSave()">{{'staffAbs.approvalFlow.save' |
        translate}}</button>
    </div>
  </form>
</div>
